﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace WindowsFormsApplication401
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();            
        }

        private void Form1_Shown(object sender, EventArgs e)
        {
            SummarySettings ss = this.ultraGrid1.DisplayLayout.Bands[0].Summaries.Add(SummaryType.Sum, this.ultraGrid1.DisplayLayout.Bands[0].Columns["Column 0"]);
            ss.SummaryType = SummaryType.Custom;
            ss.CustomSummaryCalculator = new SummaryCalculator(ultraGrid1.Rows.Count);            
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Override.SummaryDisplayArea = Infragistics.Win.UltraWinGrid.SummaryDisplayAreas.Bottom;
            e.Layout.Override.AllowRowSummaries = Infragistics.Win.UltraWinGrid.AllowRowSummaries.True;      
        }

        public class SummaryCalculator : ICustomSummaryCalculator
        {
            int[] values;
            private double total = 0;
            int times = 0;

            public SummaryCalculator(int rowsCount)
            {
                values = new int[rowsCount];
            }

            public void AggregateCustomSummary(SummarySettings settings, UltraGridRow row)
            {                
                string cellValue = row.Cells[settings.SourceColumn].Text;

                if (!values.Contains(Convert.ToInt16(cellValue)))
                {
                    values[times] = Convert.ToInt16(cellValue);
                    total += Convert.ToInt16(cellValue);
                }

                times++;
            }

            public void BeginCustomSummary(SummarySettings settings, RowsCollection rows)
            {
                this.total = 0;
            }

            public object EndCustomSummary(SummarySettings settings, RowsCollection rows)
            {
                return this.total;
            }

        }
    }
}
